//region 配置区
//region 通用配置
oald_config = {
    // 导航控制
    show_nav: true, // 显示多词义导航(仅有多词义显示)
    nav_default_all: true, // 多词义导航 是否默认显示All
    enable_control_mode: true, // 加入中文 和 例句显示按钮
    enable_concise: true, // 简明按钮, 需启用 control_mode
    concise_hide_shcut: true, // 简明模式隐藏导航词, 需启用 control_mode
    default_concise: false, // 默认显示简明, 需启用 enable_concise
    enable_concise_only_chinese: false, // 简明按钮仅显示中文, 需启用 enable_concise
    enable_nav_control_hover: false, // 导航控制鼠标滑过选中, 手机需要修改为false, 否则首次需要手动点击两次

    // 其他特性
    enable_audio_hover_pron: false, // 词头 鼠标滑过发音
    enable_definition_click_collapse: true, // 英语释义支持点击折叠,默认开启
    default_show_syllable: false, // 默认显示音节划分,点击会自动切换, 同时会发音, 设置false后打开自动发音
    headword_click_pronounce: "", // 点击词头自动发音(有音节划分展开时发音,没有直接发音)   "" -- 不发音, "BR" --英音, "US" --美音
    zhConvertLang: "", // 默认简体中文, 可选 hk, tw, twp
    chinese_selectable: true, // 中文可选

    // 显示控制
    display_translation: true, // 隐藏翻译, 默认true 显示
    expand_all: false, // 展开所有折叠, 默认false, 折叠
    collapse_idioms: false, //  折叠 Idioms
    collapse_phrasal_verb: false, // 折叠 phrasal verb
    display_hide_label_translation: false, // 隐藏label翻译,隐藏后PC端可设置true, 手机端建议默认false
    compact: false, // 紧凑样式

    // 发音,图片离在线
    online_pron: false, // 在线发音 (默认离线) 启用后,可以删除 1.mdd
    online_image: false, // 在线图片 (默认离线) 启用后,可以删除 2.mdd
    online_example_pron: false, // 在线例句发音 (默认在线) 禁用后,需要下载 3.mdd (仅捐赠用户)

    // 内容精简
    simplify_sb_sth_abbr: false, // 释义例句简化 something/somebody 缩写
    simplify_pos: false, // 简化词性, 默认false
    simplify_grammar: false, //简化语法, 默认false

    // tts 相关
    tts_online: true, // 例句,释义,在线tts发音,需要高版本浏览器内核. Mdict不支持
    tts_gb: "英音男1", // 英音发音配置  英音男1 - 英音男2  ; 英音女1 - 英音女3
    tts_us: "美音女1", // 美音发音配置  美音男1 - 美音男5 ;  美音女1 - 美音女4

    // 定制相关
    // added for laoyu
    click_display_CN: false,
    hover_display_CN: false,

    debug: false,
}
//endregion

//region 捐赠用户定制
// 折叠内容默认展开配置, added for weshor
oald_expand_custom_switch = false
oald_expand_custom_config = {
    "wordorigin": true, // 词源
    "wordfinder": true, // 联想词
    "cult": true,       // 文化
    "synonyms": true,   // 同义词辨析
    "which_word": true, // 词语辨析
    "colloc": true,     // 词语搭配
    "homophone": true,  // 同音词
    "more_about": true, // 词语辨析
    "mlt": true,        // 同类词语学习
    "wordfamily": true, // 词族
    "grammar": true,    // 语法说明
    "express": true,    // 情景表达
    "langbank": true,   // 用语库
    "vocab": true,      // 词汇扩充
    "british_american": false,  // 英式 / 美式
    "snippet": false,   // 牛津搭配词典
    "extra_examples": false, // 更多例句
    "verbforms": false, // 动词形式
}
//endregion
//endregion


is_oald_loaded = 'undefined' != typeof (is_oald_loaded)
console.log("~~~~~~~is_oald_loaded ", is_oald_loaded)

//region 常量
oald_root_class = "leon-oald"
oald_root_selector = "." + oald_root_class
oald_nav_class = "nav-oald"
oald_nav_selector = "." + oald_nav_class
oald_control_class = "control"
oald_control_selector = "." + oald_control_class

// 读取配置
var OALD_DB_PREFIX = "o10_"
Object.keys && Object.keys(oald_config)
    .filter(k => window.localStorage.getItem(OALD_DB_PREFIX + k) != null)
    .forEach(
        k => {
            let v = window.localStorage.getItem(OALD_DB_PREFIX + k);
            v = localStorageValue(OALD_DB_PREFIX + k)
            oald_config[k] = v
        }
    )

//region 修正配置
if (oald_config.debug) {
    oald_config.online_pron = true
    oald_config.online_example_pron = true
}

if (oald_config.click_display_CN) {
    oald_config.display_translation = false
    oald_config.enable_definition_click_collapse = false
    if (oald_config.enable_concise && oald_config.enable_concise_only_chinese) {
        oald_config.default_concise = false
    }
}
// 手机端禁用 mousehover
if (isMobile()) {
    oald_config.enable_nav_control_hover = false
    oald_config.enable_audio_hover_pron = false
    oald_config.hover_display_CN = false
}
//endregion

var ttsGlobalAudio = new Audio();
var globalAudio = new Audio();
var prefix_uk = "https://www.oxfordlearnersdictionaries.com/media/english/uk_pron/";
var prefix_us = "https://www.oxfordlearnersdictionaries.com/media/english/us_pron/";
var prefix_EXAMPLE = "https://oxford-x-file.oss-cn-hangzhou.aliyuncs.com/audio/xgs/xgs_audio/";
var prefix_full_image = "https://www.oxfordlearnersdictionaries.com/us/media/english/fullsize/";
var prefix_thumb_image = "https://www.oxfordlearnersdictionaries.com/us/media/english/thumb/";
//endregion

//region DOM加载初始化
!is_oald_loaded && document.addEventListener('DOMContentLoaded', function () {
    leon_oald.highlight()
    leon_oald.interaction()
    leon_oald.simplify()
    oald_config.show_nav && leon_oald.addNavigation();

    leon_oald.onlineAudioAndImage()


    oald_config.collapse_idioms && leon_oald.elementsHide(".idioms>span:not(:first-child)");
    oald_config.collapse_phrasal_verb && leon_oald.elementsHide(".phrasal_verb_links>.pvrefs");
    oald_config.display_hide_label_translation && leon_oald.elementsHide("labelx chn");

    oald_config.enable_control_mode && leon_oald.addControl()

    oald_config.debug && vConsole();
    oald_config.tts_online && leon_oald.addOnlineTts()

    let trueRoot = leon_oald.root().parentNode;
    while (!trueRoot.querySelector("script")) {
        trueRoot = trueRoot.parentNode
    }
    let path = trueRoot.querySelector("script").src;
    path = path.substring(0, path.lastIndexOf("/") + 1)
    console.log("true root path", path)
    if (path.indexOf("///android_asset/") > -1) {
        path = ""
    }
    oald_config.zhConvertLang && addScript(path + "full.min.js", function () {
        leon_oald.zhConvert()
    })

    leon_oald.compatible()

    leon_oald.addMeanClickDisplay()

    // https://caniuse.com/?search=user-select
    // moz:  firefox 69+
    // webkit chrome 54+  safari 必须
    // webkit chrome 69+
    // ms IE 10+ (Mdict PC需要)
    oald_config.chinese_selectable && leon_oald.elementsFn("chn", function (ele) {
        ele.classList.add("selectable")
    })
    oald_config.compact && leon_oald.elementsFn("li.sense,.sense_single li.sense,ul.examples,ul.examples > li", function (ele) {
        ele.classList.add("compact")
    })

    leon_oald.hoverPron()
});
//endregion

//region 全局唯一对象,进行方法隔离
leon_oald = {
    root: function () {
        let oald = document.querySelector(oald_root_selector);
        if (!oald) return document;
        return oald.parentElement ? oald.parentElement : oald;
    },

    highlight: function () {
        leon_oald.elementsFn("deft chn", function (ele) {
            ele.innerHTML = ele.innerHTML.replace(/(（[^）]+）)/g, "<span class='unimportant'>$1</span>")
        })
        // 英文例句
        leon_oald.elementsFn(".x,.unx,.def", function (ele) {
            ele.innerHTML = ele.innerHTML.replace(/(\([^)]+\))/g, "<span class='unimportant'>$1</span>")
        })
    },

    interaction: function () {
        this.elementsFn("#ox-enlarge", function (element) {
            element.addEventListener("click", function (e) {
                e.stopImmediatePropagation()
                leon_oald.toggle_enlarger(element);
            })
        });
        this.elementsFn(".box_title", function (element) {
            element.addEventListener("click", function () {
                leon_oald.toggle_active(element);
            })
            if (oald_config.expand_all)
                leon_oald.toggle_active(element)
        });
        this.elementsFn(".headword", function (element) {
            element.addEventListener("click", function () {
                leon_oald.toggle_syllable(element);
            })
            if (!oald_config.default_show_syllable)
                leon_oald.toggle_syllable(element)
        });

        this.elementsFn("chn", function (element) {
            if (!oald_config.display_translation)
                element.style.display = 'none';
        });

        this.elementsClick(".idioms>span:first-child,.phrasal_verb_links>span:first-child,.shcut", function (ele) {
            if (!ele.nextElementSibling)
                return;
            var state = ele.nextElementSibling.style.display;
            oald_config.debug && console.log("state tg", state, !state)
            if (state === "none") {
                nodeDisplay(ele, "block")
            } else {
                nodeDisplay(ele, "none")
            }
        });

        var excludeTagName = ["DEFT", "CHN"]
        // 释义 def
        oald_config.enable_definition_click_collapse && this.elementsClick(".def", function (ele) {
            if (!ele.nextElementSibling && !ele.parentNode.parentNode.querySelector(".examples")) {
                return;
            }
            let pp = false
            let next = ele.nextElementSibling;
            if (ele.nextElementSibling && ele.nextElementSibling.nextElementSibling) {
                next = ele.nextElementSibling;
                while (next.nextElementSibling && excludeTagName.indexOf(next.tagName) > -1) {
                    next = next.nextElementSibling
                }
            } else {
                next = ele.parentNode.parentNode.querySelector(".examples")
                console.log("state", next.style, next)
                pp = true
            }

            var state = next && next.style && next.style.display;
            console.log(state, ele)

            if (state === "none") {
                nodeDisplay(pp ? next : ele, "block", true, pp, function (ele) {
                    return excludeTagName.indexOf(ele.tagName) > -1
                })
            } else {
                nodeDisplay(pp ? next : ele, "none", true, pp, function (ele) {
                    return excludeTagName.indexOf(ele.tagName) > -1
                })
            }
        })
        oald_config.enable_definition_click_collapse && this.elementsClick(".def+deft", function (ele) {
            if (!ele.nextElementSibling && !ele.parentNode.parentNode.querySelector(".examples")) {
                return;
            }
            let pp = false
            let next = ele.nextElementSibling;
            if (ele.nextElementSibling) {
                next = ele.nextElementSibling;
                while (next.nextElementSibling) {
                    next = next.nextElementSibling
                }
            } else {
                next = ele.parentNode.parentNode.querySelector(".examples")
                console.log("state", next.style, next)
                pp = true
            }


            var state = next && next.style && next.style.display;
            console.log(state, ele)

            if (state === "none") {
                nodeDisplay(pp ? next : ele, "block", true, pp)
            } else {
                nodeDisplay(pp ? next : ele, "none", true, pp)
            }
        })


        let selector = Object.keys(oald_expand_custom_config)
            .filter(function (item) {
                return oald_expand_custom_config[item]
            })
            .map(function (item) {
                return "[unbox=" + item + "]"
            })
            .join(",");
        oald_expand_custom_switch && this.elementsFn(selector, function (ele) {
            leon_oald.toggle_active(ele.children[0]);
        })
    },
    simplify: function () {
        oald_config.simplify_pos && this.elementsFn(".pos", function (element) {
            element.setAttribute("title", element.textContent.replace("[", "").replace("]", ""))
            element.textContent = POS[element.textContent];
        });
        oald_config.simplify_grammar && this.elementsFn(".grammar", function (element) {
            element.setAttribute("title", element.textContent.replace("[", "").replace("]", ""))
            element.textContent = GRAMMAR[element.textContent];
        });
        // 例句不精简
        oald_config.simplify_sb_sth_abbr && this.elementsFn(".def,.cf", function (element) {
            element.innerHTML = element.innerHTML
                .replace(/\bsomething\b/g, "sth")
                .replace(/\bsomebody\b/g, "sb")
            ;
        });
    },

    onlineAudioAndImage: function () {
        // 4.mdd 例句补充
        oald_config.online_example_pron && this.elementsFn(".audio_play_button.app-ext", function (element) {
            console.log("remove", element)
            element.remove()
        });
        // 1.mdd 词头发音
        oald_config.online_pron && this.elementsFn(".audio_play_button:not(.app,.app-ext)", function (element) {
            element.href = leon_oald.get_online_pron_url(element.href);
        });
        // 3.mdd 例句
        oald_config.online_example_pron && this.elementsFn(".audio_play_button.app", function (element) {
            element.href = leon_oald.get_online_example_pron_url(element.href);
        })

        oald_config.online_image && this.elementsFn(".fullsize, .thumb", function (element) {
            element.src = leon_oald.get_online_image_url(element.src);
        });
    },
    toggle_enlarger: function (ctl) {
        var fullsize = ctl.children[0].children[0],
            thumb = ctl.children[0].children[1];
        if (!fullsize.style.display || fullsize.style.display === 'none') {
            thumb.style.display = 'none';
            fullsize.style.display = 'inline';
        } else {
            fullsize.style.display = 'none';
            thumb.style.display = 'inline';
        }
    },
    toggle_syllable: function (ctl) {
        let p = ctl.closest(".webtop").querySelector(".phonetics")
        if (!p) return

        function showPhonetic() {
            if (oald_config.default_concise && leon_oald.queryThisSelector(".more-control.collapse")) {
                showEle(p)
                let hideSelector = oald_config.headword_click_pronounce === "BR" ? ".phons_n_am" : ".phons_br"
                let ele = p.querySelector(hideSelector);
                hideEle(ele)
                setTimeout(function () {
                    hideEle(p)
                    showEle(ele)
                }, 3000)
            }
        }

        function audioClick() {
            let selector = oald_config.headword_click_pronounce === "BR" ? ".phons_br .pron-uk"
                : ".phons_n_am .pron-us"
            let audioEle = p.querySelector(selector)
            audioEle && audioEle.click()
        }

        if (ctl.hasAttribute("syllable")) {
            let isSyllable = ctl.textContent.indexOf("·") > -1;
            ctl.textContent = isSyllable ? ctl.textContent.replace(/·/g, "") : ctl.getAttribute("syllable");
            if (!isSyllable && oald_config.headword_click_pronounce) {
                audioClick()
                showPhonetic()
            }
        } else {
            // 没有syllable直接发音
            if (oald_config.headword_click_pronounce) {
                audioClick()
                showPhonetic()
            }
        }
    },
    toggle_active: function (ctl) {
        ctl.parentElement.classList.toggle('is-active');
        var examples = ctl.parentElement.querySelector('[unbox="extra_examples"] .examples');
        if (examples) {
            var isActive = ctl.parentElement.classList.contains('is-active');
            if (isActive) {
                showEle(examples);
            } else {
                hideEle(examples);
            }
        }
    },
    get_online_example_pron_url: function (src) {
        var parts = src.split('/');
        var name = parts[parts.length - 1];
        return prefix_EXAMPLE + name.replace("#", "%23").replace(".mp3", ".wav");
    },
    get_online_pron_url: function (src) {
        var parts = src.split('/');
        var name = parts[parts.length - 1];
        return (name.indexOf("_gb_") > -1 ? prefix_uk : prefix_us) + name.substring(0, 1) + '/' + name.substring(0, 3) + '/' + name.substring(0, 5) + '/' + name;
    },
    get_online_image_url: function (src) {
        let parts = src.split('/');
        let filename = parts[parts.length - 1];
        parts = filename.split('_');
        let name = filename.replace(/^(fullsize|thumb)_/g,"")
        let nameWithoutExt = name.split(".")[0]
        while (nameWithoutExt.length < 5) {
            nameWithoutExt += "_"
        }
        return (parts[0] === "fullsize" ? prefix_full_image : prefix_thumb_image) + nameWithoutExt.substring(0, 1) + '/' + nameWithoutExt.substring(0, 3) + '/' + nameWithoutExt.substring(0, 5) + '/' + name;
    },
    addNavigation: function () {
        let root = leon_oald.root();
        // 已添加不添加
        if (root.querySelector(oald_nav_selector))
            return;

        let eles = root.querySelectorAll(".oald");
        // 只有一个entry不添加
        if (eles.length < 2)
            return;
        let container = document.createElement('div');
        container.setAttribute("class", oald_nav_class);
        for (let i = 0; i < eles.length; i++) {
            let sp = document.createElement('span');
            let pos = eles[i].querySelector(".pos");
            pos = pos && pos.textContent;
            pos = !pos ? eles[i].querySelector(".headword").textContent : pos;
            sp.textContent = POS[pos] ? POS[pos] : pos.replaceAll("·", "");
            if (i === 0) {
                sp.classList.add('active');
            }
            let listener = function () {
                let index = leon_oald.navIndex(this);
                for (let j = 0; j < container.children.length; j++) {
                    container.children[j].classList.remove('active');
                }
                this.classList.add('active');
                leon_oald.showHideEntry(index)
            };
            sp.addEventListener("click", listener)
            oald_config.enable_nav_control_hover && sp.addEventListener("mouseover", listener)
            container.appendChild(sp);
        }

        // 新增All
        let sp = document.createElement('span');
        sp.textContent = "All";
        container.appendChild(sp)
        let listener1 = function () {
            for (let j = 0; j < container.children.length; j++) {
                container.children[j].classList.remove('active');
            }
            this.classList.add('active');
            leon_oald.showHideEntry(-1)
        };
        sp.addEventListener("click", listener1)
        oald_config.enable_nav_control_hover && sp.addEventListener("mouseover", listener1)
        leon_oald.showHideEntry(0);
        if (oald_config.nav_default_all) {
            sp.click();
        }
        root.insertBefore(container, root.childNodes[0]);
    },
    addControl: function () {

        let root = leon_oald.root();
        // 已添加不添加
        if (root.querySelector(oald_control_selector))
            return;

        let moreSelectors = ".collapse[hClass],.topic-g,.xrefs,.idioms,phrasal_verb_links," +
            ".phrasal_verb_links,.use,.jumplinks,.un"
        if (oald_config.concise_hide_shcut) {
            moreSelectors += ",.shcut"
        }
        let moreSelectorsInline = (oald_config.enable_concise_only_chinese ? ".def," : "") + ".inflections .phonetics,.variants .phonetics"

        // 简化语法时显示
        if (!oald_config.simplify_grammar) {
            moreSelectorsInline += ",.grammar"
        }
        let moreSelectorsInlineBlock = ".variants"
        console.log(this.thisSelector(moreSelectors), this.thisSelector(moreSelectorsInline));
        let zhs = leon_oald.queryThisSelector("chn")
        // 仅释义例句，扩展例句不显示
        let example = leon_oald.queryThisSelector(".examples .x")
        let more = leon_oald.queryThisSelector(moreSelectors) || example
        if (!zhs && !example && (!oald_config.enable_concise || !more)) {
            return;
        }

        this.elementsFn(".headword ~.pos,.leon-oald.idm-g .idm,.headword", function (ele) {
            if (ele.classList.contains("headword") && (ele.nextElementSibling.classList.contains("pos"))) {
                return
            }
            console.log("-----------")

            let container = document.createElement('span');
            container.setAttribute("class", oald_control_class);
            // 存在chn才显示
            // 存在examples才显示
            let chnEle;
            if (zhs) {
                chnEle = document.createElement('span');
                chnEle.textContent = "隐中"
                chnEle.classList.add("chn-control")
                if (!oald_config.display_translation) {
                    chnEle.classList.add('collapse');
                }
                let exclude = oald_config.display_hide_label_translation ? ":not(labelx chn)" : ""
                let chnListener = function () {
                    // 简明模式下，无法进行中文控制
                    if (leon_oald.queryThisSelector(".more-control.collapse")) {
                        return
                    }
                    leon_oald.elementsFn(".chn-control", function (ele) {
                        ele.classList.toggle('collapse');
                    })

                    leon_oald.elementsDisplay("chn" + exclude, this.classList.contains('collapse') ? "none" : "inline")
                };
                chnEle.addEventListener("click", chnListener)
                oald_config.enable_nav_control_hover && chnEle.addEventListener("mouseover", chnListener)
                container.appendChild(chnEle);
            }
            // 存在examples才显示
            let examplesEle;
            if (example) {
                examplesEle = document.createElement('span');
                examplesEle.textContent = "隐例"
                examplesEle.classList.add("examples-control")
                let exampleListener = function () {
                    leon_oald.elementsFn(".examples-control", function (ele) {
                        ele.classList.toggle('collapse');
                    })
                    leon_oald.elementsFn(".examples", function (ele) {
                        if (!ele.parentNode.classList.contains("unbox")) {
                            ele.style.display = examplesEle.classList.contains('collapse') ? "none" : "block"
                        }
                    })
                };
                examplesEle.addEventListener("click", exampleListener)
                oald_config.enable_nav_control_hover && examplesEle.addEventListener("mouseover", exampleListener)
                container.appendChild(examplesEle);
            }
            let moreEle
            if (oald_config.enable_concise && more) {
                moreEle = document.createElement('span');
                moreEle.textContent = "简明"
                moreEle.classList.add("more-control")
                let moreListener = function () {
                    leon_oald.elementsFn(".more-control", function (ele) {
                        if (chnEle && chnEle.classList.contains("collapse") && !ele.classList.contains("collapse")) {
                            chnEle.click()
                        }
                        ele.classList.toggle('collapse');

                        if (ele.classList.contains("collapse")) {
                            leon_oald.elementsHide(moreSelectors)
                            leon_oald.elementsHide(moreSelectorsInline)
                            leon_oald.elementsDisplay(moreSelectorsInlineBlock, "inline-block")
                            oald_config.enable_concise_only_chinese && leon_oald.elementsFn(".dtxt", function (ele) {
                                const no = ele.childNodes[0];
                                console.log('-----', ele, no, no.nodeType)
                                if (no && no.nodeType === 3) {
                                    ele.setAttribute("data", no.textContent)
                                    ele.removeChild(no)
                                }
                            })

                            if (chnEle && chnEle.classList.contains("collapse")) {
                                chnEle.click()
                            }
                            if (examplesEle && !examplesEle.classList.contains("collapse")) {
                                examplesEle.click()
                            }
                        } else {
                            leon_oald.elementsShow(moreSelectors)
                            leon_oald.elementsShow(moreSelectorsInlineBlock)
                            oald_config.enable_concise_only_chinese && leon_oald.elementsFn(".dtxt", function (ele) {
                                if (ele.hasAttribute("data") && ele.firstChild.nodeType !== 3) {
                                    const text = document.createTextNode(ele.getAttribute("data"));
                                    ele.insertBefore(text, ele.firstChild);
                                }
                            })
                            if (moreSelectorsInline) {
                                leon_oald.elementsDisplay(moreSelectorsInline, "inline")
                            }
                            if (examplesEle && examplesEle.classList.contains("collapse")) {
                                examplesEle.click()
                            }
                        }
                    })

                };
                moreEle.addEventListener("click", moreListener)
                oald_config.enable_nav_control_hover && moreEle.addEventListener("mouseover", moreListener)
                container.appendChild(moreEle);
            }
            if (ele.classList.contains("idm")) {
                ele.appendChild(container)
            } else {
                ele.insertAdjacentElement("afterend", container)
            }
        })

        more && oald_config.enable_concise && oald_config.default_concise && this.queryThisSelector(".more-control").click()
    },
    navIndex: function (ele) {
        var eles = document.querySelectorAll(oald_nav_selector + " span");
        for (var i = 0; i < eles.length; i++) {
            if (eles[i] === ele)
                return i;
        }
    },
    showHideEntry: function (index) {
        var eles = document.querySelectorAll(oald_root_selector);
        for (var i = 0; i < eles.length; i++) {
            if (index === i || index < 0)
                showEle(eles[i]);
            else
                hideEle(eles[i]);
        }
    },
    addMeanClickDisplay: function () {
        // click hide show chinese
        let selector = ".x,.def,.def+deft,.unx, .defpara, .unbox[unbox=wordorigin] .body ,[un=help]";

        function clickDisplay(ele) {
            // 简明模式下，无法进行中文控制
            if (leon_oald.queryThisSelector(".more-control.collapse")) {
                return
            }
            let zh = ele.querySelector("chn")
            if (!zh && ele.nextElementSibling.querySelector("chn")) {
                zh = ele.nextElementSibling.querySelector("chn")
            }
            zh = zh ? zh : ele.parentNode.querySelector("chn");
            if (zh) {
                zh.style.display = zh.style.display === "none" || zh.style.display === "" ? "inline" : "none";
            }
        }

        oald_config.click_display_CN && leon_oald.elementsClick(selector, function (ele, event) {
            event.stopImmediatePropagation()
            clickDisplay(ele)
        })
        oald_config.hover_display_CN && leon_oald.elementsEvent(selector, "mouseover", function (ele, event) {
            clickDisplay(ele)
        })
    },
    addOnlineTts: function () {
        if (typeof speak === "undefined") {
            return
        }

        function speakNode(ele) {
            var cp = ele.cloneNode(true);
            leon_oald.nodeElementsFn(cp, "chn,script,.icon-audio", function (ele) {
                ele.remove()
            })
            speak(cp.textContent.replace(/\(.*?\)/g, ""));
        }

        // 在线tts
        this.elementsFn(".x,.unx", function (element) {
            oald_config.debug && console.log("______addOnlineTts", element)
            const targetEle = element.querySelector("xt,unxt,chn")
            if (!element.querySelector(".pron-uk")) {
                let pron_uk = document.createElement('span');
                pron_uk.setAttribute("class", "sound audio_play_button pron-uk icon-audio");
                pron_uk.onclick = function () {
                    selectedTts = oald_config.tts_gb;
                    speakNode(element)
                }
                element.insertBefore(pron_uk, targetEle);
            }
            if (!element.querySelector(".pron-us")) {
                let pron_us = document.createElement('span');
                pron_us.setAttribute("class", "sound audio_play_button pron-us icon-audio");
                pron_us.onclick = function () {
                    selectedTts = oald_config.tts_us;
                    speakNode(element)
                }
                element.insertBefore(pron_us, targetEle);
            }
        });
    },
    hoverPron: function () {
        oald_config.enable_audio_hover_pron && this.elementsFn(".icon-audio", function (ele) {
            ele.addEventListener("mouseover", function (e) {
                this.click()
            })
        })
    },
    compatible: function () {
        // fix Oxford Collocations Dictionary牛津搭配词典 双击选中多余内容 (官网同样有问题)
        this.elementsFn(".collocs_list li.li", function (ele) {
            ele.insertAdjacentText('afterend', ' ');
        })

        var selector = ""
        // 欧路额外处理
        if (this.isEudic()) {
            if (!oald_config.online_example_pron && !oald_config.online_pron) {
                return
            }
            if (oald_config.online_pron) {
                selector = ".phonetics a.icon-audio"
            }
            if (oald_config.online_example_pron) {
                selector = (selector ? selector + "," : "") + "a.icon-audio:not(.phonetics a.icon-audio)"
            }

            console.log("eudic", oald_config.online_pron, oald_config.online_example_pron, selector)

        } else {
            selector = "a.icon-audio"
        }
        // 覆写所有 a.icon-audio事件
        oald_config.debug && console.log("---------- a tag: online compatible")

        function audioClick() {
            return function (ele, event) {
                oald_config.debug && console.log("----------", ele.href)
                // a标签 在线发音
                event.stopImmediatePropagation()
                event.preventDefault()
                globalAudio.pause()
                ttsGlobalAudio.pause()
                globalAudio.src = ele.href;
                globalAudio.play();
            };
        }

        this.elementsEvent(selector, "click", audioClick())
    },
    //region 通用功能
    thisSelector: function (selector) {
        return selector.split(",").map(function (s) {
                return s.indexOf(oald_root_selector) > -1 ? s : (oald_root_selector + " " + s)
            }
        )
            .join(",")
    },
    queryThisSelector: function (selector) {
        return document.querySelector(oald_root_selector + " " + selector.split(",").join("," + oald_root_selector + " "))
    },
    queryThisSelectorAll: function (selector) {
        return document.querySelectorAll(oald_root_selector + " " + selector.split(",").join("," + oald_root_selector + " "))
    },
    // common
    elementsFn: function (selector, fn) {
        if (!selector) {
            return
        }
        selector = this.thisSelector(selector)
        var eles = document.querySelectorAll(selector);
        for (var i = 0; i < eles.length; i++) {
            fn(eles[i]);
        }
    },
    nodeElementsFn: function (node, selector, fn) {
        if (!node || !selector) {
            return
        }
        var eles = node.querySelectorAll(selector)
        for (var i = 0; i < eles.length; i++) {
            fn(eles[i]);
        }
    },

    elementsClick: function (selector, fn) {
        this.elementsEvent(selector, "click", fn)
    },

    css: function (selector, obj) {
        if (!selector) {
            return
        }
        this.elementsFn(selector, function (ele) {
            Object.keys(obj).forEach(function (key) {
                ele.style[key] = obj[key]
            })
        })
    },
    elementsEvent: function (selector, eventName, fn) {
        var events = eventName.split(",")
        for (let i = 0; i < events.length; i++) {
            this.elementsFn(selector, function (ele) {
                ele.addEventListener(events[i], function (event) {
                    fn(ele, event);
                })
            })
        }
    },
    elementEvent: function (ele, eventName, fn) {
        var events = eventName.split(",")
        for (let i = 0; i < events.length; i++) {
            ele.addEventListener(events[i], function (event) {
                fn(event, ele);
            })
        }
    },
    elementsDisplay: function elementsDisplay(selector, value) {
        this.elementsFn(selector, function (ele) {
            ele.style.display = value;
        })
    },

    elementsHide: function (selector) {
        this.elementsDisplay(selector, "none")
    },

    elementsShow: function elementsShow(selector) {
        this.elementsDisplay(selector, "block")
    },
    //endregion

    //region 调试兼容
    isDebug: function () {
        return this.isPC() && !this.isDictApp()
    },
    isPC: function () {
        const ua = navigator.userAgent
        return ua.indexOf("Edge") > -1
            || ua.indexOf("Chrome") > -1
            || ua.indexOf("Firefox") > -1
            || ua.indexOf("Safari") > -1
    },
    isDictApp: function () {
        const ua = navigator.userAgent.toLowerCase()
        return ua.indexOf("goldendict") > -1
            || ua.indexOf("eudic") > -1
            // MDICT
            || ua.indexOf(".net4.0") > -1
            || ua.indexOf("iphone") > -1
            || ua.indexOf("android") > -1
            || ua.indexOf("ipad") > -1
    },
    isMobile: function () {
        const ua = navigator.userAgent.toLowerCase()
        return ua.indexOf("iphone") > -1
            || ua.indexOf("android") > -1
            || ua.indexOf("ipad") > -1
    },
    isMDict: function () {
        return navigator.userAgent.toLowerCase().indexOf(".net4.0") > -1
    },
    isGoldenDict: function () {
        return navigator.userAgent.toLowerCase().indexOf("goldendict") > -1
    },
    isEudic: function () {
        return navigator.userAgent.toLowerCase().indexOf("eudic") > -1
    },
    zhConvert: function () {
        if (!oald_config.zhConvertLang) return
        const converter = OpenCC.Converter({from: 'cn', to: oald_config.zhConvertLang});
        this.elementsFn("chn", function (ele) {
            if (ele.childElementCount === 0) {
                ele.innerText = converter(ele.innerText)
            } else {
                ele.firstChild.innerText = converter(ele.firstChild.innerText)
            }
        })
    }
    //endregion
}
//endregion

//region 词性替换表
var POS = {
    "noun": "n.",
    "adjective": "adj.",
    "adverb": "adv.",
    "abbreviation": "abbr.",
    "adverb, adjective": "adv., adj.",
    "verb": "v.",
    "phrasal verb": "phrasal v.",
    "exclamation": "interj.",
    "idiom": "idiom",
    "conjunction": "conj.",
    "preposition": "prep.",
    "modal verb": "modal v.",
    "combining form": "combining form",
    "prefix": "prefix",
    "linking verb": "linking v.",
    "suffix": "suffix",
    "number": "num.",
    "pronoun": "pron.",
    "ordinal number": "ordinal num.",
    "determiner": "det.",
    "auxiliary verb": "aux. v.",
    "indefinite article": "indefinite a.",
    "definite article": "definite a.",
    "infinitive marker": "infinitive marker",
    "symbol": "symbol",
    "adjective, adverb": "adj., adv.",
    "adverb, preposition": "adv., prep.",
    "noun, adjective": "n., adj.",
    "short form": "short form",
    "noun, exclamation": "n., interj.",
    "exclamation, noun": "interj., n.",
    "determiner, pronoun": "det., pron.",
    "preposition, adverb": "prep., adv.",
    "adjective, exclamation": "adj., interj.",
    "preposition, conjunction, adverb": "prep., conj., adv.",
    "adjective, adverb, exclamation": "adj., adv., interj.",
    "adjective, noun": "adj., n.",
    "adverb, exclamation": "adv., interj.",
    "noun, determiner": "n., det.",
    "determiner, pronoun, adverb": "det., pron., adv.",
    "conjunction, preposition": "conj., prep.",
    "adverb, pronoun, conjunction": "adv., pron., conj.",
    "determiner, adjective": "det., adj.",
    "determiner, ordinal number": "det., ordinal num.",
    "noun, abbreviation": "n., abbr.",
    "exclamation, adjective": "interj., adj.",
    "conjunction, adverb": "conj., adv.",
    "adjective, pronoun": "adj., pron.",
    "number, determiner": "num., det.",
    "noun, verb": "n., v.",
    "pronoun, determiner": "pron., det.",
    "preposition, conjunction": "prep., conj.",
    "exclamation, adverb, pronoun": "interj., adv., pron.",
    "adverb, conjunction": "adv., conj.",
    "adverb, noun": "adv., n.",
}
//endregion

//region 语法替换表
var GRAMMAR = {
    "[uncountable]": "[U]",
    "[only before noun]": "[only bf N]",
    "[singular]": "[sing]",
    "[countable]": "[C]",
    "[countable, uncountable]": "[C, U]",
    "[after noun]": "[aft N]",
    "[not before noun]": "[not bf N]",
    "[usually before noun]": "[usu bf N]",
    "[usually singular]": "[usu sing]",
    "[uncountable, countable]": "[U, C]",
    "[intransitive, transitive]": "[I, T]",
    "[usually passive]": "[usu psv]",
    "[plural]": "[pl]",
    "[transitive]": "[T]",
    "[uncountable, singular]": "[U, sing]",
    "[intransitive]": "[I]",
    "[often passive]": "[oft psv]",
    "[not usually before noun]": "[not usu bf N]",
    "[singular, uncountable]": "[sing, U]",
    "[uncountable, plural]": "[U, pl]",
    "[usually plural]": "[usu pl]",
    "[countable, usually plural]": "[C, usu pl]",
    "[uncountable, countable, usually singular]": "[U, C, usu sing]",
    "[transitive, intransitive]": "[T, I]",
    "[intransitive, transitive, often passive]": "[I, T, oft psv]",
    "[transitive, often passive]": "[T, oft psv]",
    "[countable, usually singular]": "[C, usu sing]",
    "[countable + singular or plural verb]": "[C + sing or pl V]",
    "[uncountable + singular or plural verb]": "[U + sing or pl V]",
    "[transitive, usually passive]": "[T, usu psv]",
    "[transitive, often passive, intransitive]": "[T, oft psv, I]",
    "[no passive]": "[no psv]",
    "[countable, usually singular, uncountable]": "[C, usu sing, U]",
    "[countable, usually plural, uncountable]": "[C, usu pl, U]",
    "[plural, singular or plural verb]": "[pl, sing or pl V]",
    "[singular + singular or plural verb]": "[sing + sing or pl V]",
    "[countable, singular, uncountable]": "[C, sing, U]",
    "[intransitive, transitive, no passive]": "[I, T, no psv]",
    "[transitive, no passive]": "[T, no psv]",
    "[uncountable, countable, usually plural]": "[U, C, usu pl]",
    "[plural, uncountable]": "[pl, U]",
    "[countable + singular or plural verb, uncountable]": "[C + sing or pl V, U]",
    "[transitive, intransitive, often passive]": "[T, I, oft psv]",
    "[intransitive, transitive, usually passive]": "[I, T, usu psv]",
    "[transitive, usually passive, intransitive]": "[T, usu psv, I]",
    "[countable, plural]": "[C, pl]",
    "[singular or plural verb]": "[sing or pl V]",
    "[countable, uncountable + singular or plural verb]": "[C, U + sing or pl V]",
    "[uncountable + singular or plural verb, countable]": "[U + sing or pl V, C]",
    "[countable, singular]": "[C, sing]",
    "[uncountable, countable, singular]": "[U, C, sing]",
    "[countable, singular + singular or plural verb]": "[C, sing + sing or pl V]",
    "[singular + singular or plural verb, uncountable]": "[sing + sing or pl V, U]",
    "[transitive, no passive, intransitive]": "[T, no psv, I]",
    "[usually singular, uncountable]": "[usu sing, U]",
    "[transitive, intransitive, usually passive]": "[T, I, usu psv]",
}
//endregion

//region 通用方法
function localStorageValue(key) {
    const v = window.localStorage.getItem(key);
    return v === "true" || v === "false" ? v === "true" : v;
}

function hideEle(ele) {
    ele.style.display = 'none';
}

function showEle(ele) {
    ele.style.display = 'block';
}

function showEleInline(ele) {
    ele.style.display = 'inline';
}

function nodeDisplay(node, value, fromThis, includeThis, excludeFunc, inlineList) {
    var nodes = node.parentElement.childNodes;
    var isFindThis = false
    console.log("got length", nodes.length, value)
    for (var i = 0; i < nodes.length; i++) {
        let currentNode = nodes[i];
        if (excludeFunc && excludeFunc(currentNode)) {
            continue;
        }
        if (fromThis) {
            if (node === currentNode) {
                console.log("\t\tgot node", node)
                isFindThis = true;
            }
            if (!isFindThis)
                continue;
        }
        if (!includeThis && node === currentNode)
            continue;

        console.log("\t\tcurrentNode", currentNode)
        if (currentNode.style) {
            console.log("\t\t style", currentNode.style.display)
            var display = "block"
            if (inlineList && inlineList.indexOf(currentNode.className) > -1) {
                display = "inline"
            }
            currentNode.style.display = value === "block" ? display : value;
            console.log("\t\t style after", currentNode.style.display)
        }
    }
}

function isMobile() {
    const ua = navigator.userAgent.toLowerCase()
    return ua.indexOf("iphone") > -1
        || ua.indexOf("android") > -1
        || ua.indexOf("ipad") > -1
}


function addScript(src, func) {
    let script = document.createElement('script');
    script.type = 'text/javascript';
    document.body.appendChild(script);
    if (src) {
        script.src = src;
    }
    script.onload = func;
}

function vConsole() {
    if ('undefined' == typeof (VConsole)) {
        addScript("https://cdn.bootcss.com/vConsole/3.15.0/vconsole.min.js", function () {
            var vConsole = new VConsole();
        })
    }
}

//endregion

//region 浏览器兼容
if (typeof Element !== "undefined") {
    if (!Element.prototype.matches) {
        Element.prototype.matches = Element.prototype.msMatchesSelector || Element.prototype.webkitMatchesSelector;
    }

    if (!Element.prototype.closest) {
        Element.prototype.closest = function (s) {
            var el = this;

            do {
                if (el.matches(s)) return el;
                el = el.parentElement || el.parentNode;
            } while (el !== null && el.nodeType === 1);

            return null;
        };
    }
}
//endregion

//region tts 功能
var ttsConfig = {
    "美音女1": {
        locale: "en-US",
        voice: "en-US-MichelleNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "美音女2": {
        locale: "en-US",
        voice: "en-US-AriaNeural",
        pitch: "+0Hz",
        rate: "+20%",
        volume: "+0%",
    },
    "美音女3": {
        locale: "en-US",
        voice: "en-US-AnaNeural",
        pitch: "+0Hz",
        rate: "+20%",
        volume: "+0%",
    },
    "美音女4": {
        locale: "en-US",
        voice: "en-US-JennyNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "美音男1": {
        locale: "en-US",
        voice: "en-US-ChristopherNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "美音男2": {
        locale: "en-US",
        voice: "en-US-EricNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "美音男3": {
        locale: "en-US",
        voice: "en-US-GuyNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "美音男4": {
        locale: "en-US",
        voice: "en-US-RogerNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "美音男5": {
        locale: "en-US",
        voice: "en-US-SteffanNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "英音女1": {
        locale: "en-GB",
        voice: "en-GB-SoniaNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "英音女2": {
        locale: "en-GB",
        voice: "en-GB-MaisieNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "英音女3": {
        locale: "en-GB",
        voice: "en-GB-LibbyNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "英音男1": {
        locale: "en-GB",
        voice: "en-GB-RyanNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "英音男2": {
        locale: "en-GB",
        voice: "en-GB-ThomasNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
}

var selectedTts = "美音女1";

function create_edge_TTS(
    timeout = 10,
    auto_reconnect = true) {

    const TRUSTED_CLIENT_TOKEN = "6A5AA1D4EAFF4E9FB37E23D68491D6F4";
    const VOICES_URL = `https://speech.platform.bing.com/consumer/speech/synthesize/readaloud/voices/list?trustedclienttoken=${TRUSTED_CLIENT_TOKEN}`;
    const SYNTH_URL = `wss://speech.platform.bing.com/consumer/speech/synthesize/readaloud/edge/v1?TrustedClientToken=${TRUSTED_CLIENT_TOKEN}`;
    const BINARY_DELIM = "Path:audio\r\n";
    const VOICE_LANG_REGEX = /\w{2}-\w{2}/;

    let _outputFormat = "audio-24khz-48kbitrate-mono-mp3";
    /* 修改发音人和语言 */
    let _voiceLocale = 'en-US',
        _voice = 'en-US-MichelleNeural',
        // 调整音色
        _pitch = '+0Hz',
        // 调整速度
        _rate = '+20%',
        // 调整音量
        _volume = '+0%';

    const _queue = {
        message: [],
        url_resolve: {},
        url_reject: {},
    };

    let ready = false;

    function _SSMLTemplate(input) {
        return `<speak version="1.0" xmlns="http://www.w3.org/2001/10/synthesis" xmlns:mstts="https://www.w3.org/2001/mstts" xml:lang="${ttsConfig[selectedTts].voiceLocale}">
                  <voice name="${ttsConfig[selectedTts].voice}">
				   <prosody pitch="${ttsConfig[selectedTts].pitch}" rate="${ttsConfig[selectedTts].rate}" volume="${ttsConfig[selectedTts].volume}">${input}</prosody>
                  </voice>
              </speak>`;
    }

    function uuidv4() {
        return ([1e7] + -1e3 + -4e3 + -8e3 + -1e11).replace(/[018]/g, c =>
            (c ^ crypto.getRandomValues(new Uint8Array(1))[0] & 15 >> c / 4).toString(16));
    }

    let socket = null;
    create_new_ws();

    function setFormat(format) {
        if (format)
            _outputFormat = format;

        /**/
        socket.send(`Content-Type:application/json; charset=utf-8\r\nPath:speech.config\r\n\r\n
                      {
                          "context": {
                              "synthesis": {
                                  "audio": {
                                      "metadataoptions": {
                                          "sentenceBoundaryEnabled": "false",
                                          "wordBoundaryEnabled": "false"
                                      },
                                      "outputFormat": "${_outputFormat}" 
                                  }
                              }
                          }
                      }
                  `);
    }

    async function createURL(requestId) {
        let index_message = 0;
        for (let message of _queue.message) {
            const isbinary = message instanceof Blob;

            if (!isbinary)
                continue;

            const data = await message.text();

            //console.log(data); //does the message order change?
            //console.log(await event.data.arrayBuffer());

            const Id = /X-RequestId:(.*?)\r\n/gm.exec(data)[1];

            if (Id !== requestId)
                continue;

            if (data.charCodeAt(0) === 0x00 && data.charCodeAt(1) === 0x67 && data.charCodeAt(2) === 0x58) {
                // Last (empty) audio fragment
                oald_config.debug && console.log(`Last (empty) audio fragment`)

                const blob = new Blob(_queue[requestId], {
                    'type': 'audio/mp3'
                });

                _queue[requestId] = null; //release memory

                const url = URL.createObjectURL(blob);
                oald_config.debug && console.log(url)

                //URL.revokeObjectURL(url);
                _queue.url_resolve[requestId](url);

                //return url

            } else {
                const index = data.indexOf(BINARY_DELIM) + BINARY_DELIM.length;

                const audioData = message.slice(index);
                _queue[requestId].push(audioData);

                _queue.message[index_message] = null; //release blob memory
            }

            ++index_message;
        }
    }

    function onopen(event) {
        console.log('open');
        //socket.send('Hello Server!');
        //socket.close()

        setFormat();
        ready = true;
    }

    async function onmessage(event) {
        const isbinary = event.data instanceof Blob;
        oald_config.debug && console.log(`Message from server, type: ${typeof (event.data)} Blob: ${isbinary}`);
        _queue.message.push(event.data)
        if (!isbinary) {
            //console.log(event.data);
            const requestId = /X-RequestId:(.*?)\r\n/gm.exec(event.data)[1];

            if (event.data.includes("Path:turn.end")) {
                // end of turn
                createURL(requestId);
            }

        } else {
        }
    }

    function onerror(event) {
        ready = false;
        console.log('WebSocket error: ', event);
    }

    function onclose(event) {
        ready = false;
        console.log('WebSocket close: ', event); //may be closed by remote
    }

    function addSocketListeners() {
        socket.addEventListener('open', onopen);
        // Listen for messages
        socket.addEventListener('message', onmessage);

        // Listen for possible errors
        socket.addEventListener('error', onerror);

        // Listen for possible errors
        socket.addEventListener('close', onclose);
    }

    function create_new_ws() {
        //try {
        // Create WebSocket connection.
        socket = new WebSocket(SYNTH_URL);
        addSocketListeners();
    }

    let toStream = function (input) {
        let requestSSML = _SSMLTemplate(input);
        const requestId = uuidv4().replaceAll('-', '');
        const request = `X-RequestId:${requestId}\r\nContent-Type:application/ssml+xml\r\nPath:ssml\r\n\r\n
                  ` + requestSSML.trim();

        _queue[requestId] = [];

        return new Promise((resolve, reject) => {
            _queue.url_resolve[requestId] = resolve,
                _queue.url_reject[requestId] = reject;

            if (!ready) {
                if (auto_reconnect) {
                    create_new_ws();
                    socket.addEventListener('open', _ => socket.send(request));

                    setTimeout(_ => {
                        if (!ready)
                            reject('reconnect timeout')
                    }, timeout * 1000);
                } else
                    reject('socket error or timeout');
            } else {
                socket.send(request)
            }

        });

    }

    async function play(input, play_count = 1, play_span = 5000) {
        const url = await toStream(input);

        let play_resolve = function () {
        };

        globalAudio.pause()
        ttsGlobalAudio.pause();
        ttsGlobalAudio.src = url;
        ttsGlobalAudio.onended = (e) => {
            if (--play_count > 0) {
                oald_config.debug && console.log("play----");
                setTimeout(_ => ttsGlobalAudio.play(), play_span);
            } else {
                //URL.revokeObjectURL(url);
                play_resolve(url);
                oald_config.debug && console.log('play end');
            }
        }

        await ttsGlobalAudio.play();
        oald_config.debug && console.log('after play' + ttsGlobalAudio.duration);

        return new Promise((resolve, reject) => {
            play_resolve = resolve
        });

    }

    return new Promise((resolve, reject) => {
        setTimeout(_ => reject('socket open timeout'), timeout * 1000);
        // Connection opened
        socket.addEventListener('open', function (event) {

            resolve({
                _: play,
                toStream,
                setVoice: (voice, locale) => {
                    _voice = voice;
                    if (!locale) {
                        const voiceLangMatch = VOICE_LANG_REGEX.exec(_voice);
                        if (!voiceLangMatch)
                            throw new Error("Could not infer voiceLocale from voiceName!");
                        _voiceLocale = voiceLangMatch[0];
                    } else {
                        _voiceLocale = locale;
                    }
                },
                setFormat,
                isReady: _ => ready
            })
        });
    });

}

var tts;

async function init() {
    tts = await create_edge_TTS();
}

typeof Promise != "undefined" && init();

//-------------------------------

async function speak(chn) {
    try {
        await tts._(chn)
    } catch (e) {
        console.log('catch error:')
        console.log(e)
    }
}

//endregion
